blob: 4e41897a901f1a245a19785838e4412ba8087b3e [file] [log] [blame]
Don Newton98fd8812019-09-23 15:15:02 -04001#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
17# set default shell
18SHELL = bash -e -o pipefail
19
20# Variables
Kent Hagerman6379e092020-02-18 18:05:57 -050021VERSION ?= $(shell cat ./VERSION)
Don Newton98fd8812019-09-23 15:15:02 -040022
23DOCKER_LABEL_VCS_DIRTY = false
24ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
25 DOCKER_LABEL_VCS_DIRTY = true
26endif
27## Docker related
Kent Hagerman6379e092020-02-18 18:05:57 -050028DOCKER_EXTRA_ARGS ?=
29DOCKER_REGISTRY ?=
30DOCKER_REPOSITORY ?=
31DOCKER_TAG ?= ${VERSION}$(shell [[ ${DOCKER_LABEL_VCS_DIRTY} == "true" ]] && echo "-dirty" || true)
Zack Williamsa054c7f2020-03-23 10:19:29 -070032ADAPTER_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-ofagent-go
Don Newton98fd8812019-09-23 15:15:02 -040033
34## Docker labels. Only set ref and commit date if committed
35DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote))
36DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD)
37DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ")
38DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD)
39
40DOCKER_BUILD_ARGS ?= \
41 ${DOCKER_EXTRA_ARGS} \
42 --build-arg org_label_schema_version="${VERSION}" \
43 --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \
44 --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \
45 --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \
46 --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \
47 --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}"
48
49DOCKER_BUILD_ARGS_LOCAL ?= ${DOCKER_BUILD_ARGS} \
50 --build-arg LOCAL_PROTOS=${LOCAL_PROTOS}
51
Kent Hagerman6379e092020-02-18 18:05:57 -050052# tool containers
Matteo Scandolo154295f2020-11-23 15:29:02 -080053VOLTHA_TOOLS_VERSION ?= 2.3.1
Kent Hagerman6379e092020-02-18 18:05:57 -050054
55GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go
56GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report
Matteo Scandolo154295f2020-11-23 15:29:02 -080057GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app/src/github.com/opencord/ofagent-go -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura
Kent Hagerman6379e092020-02-18 18:05:57 -050058GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint
59HADOLINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-hadolint hadolint
60
divyadesai892fab52020-03-24 08:45:09 +000061.PHONY: local-protos local-voltha
Don Newton98fd8812019-09-23 15:15:02 -040062
63# This should to be the first and default target in this Makefile
64help:
65 @echo "Usage: make [<target>]"
66 @echo "where available targets are:"
67 @echo
divyadesai892fab52020-03-24 08:45:09 +000068 @echo "build : Build ofagent-go docker image"
Don Newton98fd8812019-09-23 15:15:02 -040069 @echo "docker-build : Build ofagent-go docker image"
70 @echo "help : Print this help"
71 @echo "docker-push : Push the docker images to an external repository"
72 @echo "lint : Run lint verification, depenancy, gofmt and reference check"
73 @echo "sca : Runs various SCA through golangci-lint tool"
74 @echo "test : Run unit tests, if any"
75 @echo
76
77
78## Local Development Helpers
79
80local-protos:
81ifdef LOCAL_PROTOS
82 mkdir -p vendor/github.com/opencord/voltha-protos/go
83 cp -r ${GOPATH}/src/github.com/opencord/voltha-protos/go/* vendor/github.com/opencord/voltha-protos/go
84endif
85
divyadesai892fab52020-03-24 08:45:09 +000086## Local Development Helpers
87local-lib-go:
88ifdef LOCAL_LIB_GO
Maninder12b909f2020-10-23 14:23:36 +053089 mkdir -p vendor/github.com/opencord/voltha-lib-go/v4/pkg
90 cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v4/pkg/
divyadesai892fab52020-03-24 08:45:09 +000091endif
92
93
Don Newton98fd8812019-09-23 15:15:02 -040094local-voltha:
95ifdef LOCAL_VOLTHA
96 mkdir -p vendor/github.com/opencord/voltha-go/
97 cp -rf ${GOPATH}/src/github.com/opencord/voltha-go/ vendor/github.com/opencord/
98 rm -rf vendor/github.com/opencord/voltha-go/vendor
99endif
100
divyadesai892fab52020-03-24 08:45:09 +0000101## Docker targets
102build: docker-build
Don Newton98fd8812019-09-23 15:15:02 -0400103
104## Docker targets
105
divyadesai892fab52020-03-24 08:45:09 +0000106docker-build: local-protos local-voltha local-lib-go
Matteo Scandoloa98f0dc2020-05-13 10:39:29 -0700107 docker build $(DOCKER_BUILD_ARGS) -t ${ADAPTER_IMAGENAME}:${DOCKER_TAG} -f docker/Dockerfile.ofagent-go .
108ifdef BUILD_PROFILED
109 docker build $(DOCKER_BUILD_ARGS) --build-arg EXTRA_GO_BUILD_TAGS="-tags profile" -t ${ADAPTER_IMAGENAME}:${DOCKER_TAG}-profile -f docker/Dockerfile.ofagent-go .
110endif
Don Newton98fd8812019-09-23 15:15:02 -0400111
112docker-push:
Kent Hagerman6379e092020-02-18 18:05:57 -0500113 docker push ${ADAPTER_IMAGENAME}:${DOCKER_TAG}
Matteo Scandoloa98f0dc2020-05-13 10:39:29 -0700114ifdef BUILD_PROFILED
115 docker push ${ADAPTER_IMAGENAME}:${DOCKER_TAG}-profile
116endif
Don Newton98fd8812019-09-23 15:15:02 -0400117
118## lint and unit tests
119
Kent Hagerman6379e092020-02-18 18:05:57 -0500120lint-dockerfile:
121 @echo "Running Dockerfile lint check..."
122 @${HADOLINT} $$(find . -name "Dockerfile.*")
123 @echo "Dockerfile lint check OK"
124
Don Newtone0d34a82019-11-14 10:58:06 -0500125lint-mod:
Don Newton98fd8812019-09-23 15:15:02 -0400126 @echo "Running dependency check..."
Kent Hagerman6379e092020-02-18 18:05:57 -0500127 @${GO} mod verify
128 @echo "Dependency check OK. Running vendor check..."
129 @git status > /dev/null
Kent Hagerman3243ee52020-02-26 12:11:55 -0500130 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && git status -- go.mod go.sum vendor && exit 1)
131 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && git status -- go.mod go.sum vendor && exit 1)
Kent Hagerman6379e092020-02-18 18:05:57 -0500132 ${GO} mod tidy
133 ${GO} mod vendor
134 @git status > /dev/null
Kent Hagerman3243ee52020-02-26 12:11:55 -0500135 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
136 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
Kent Hagerman6379e092020-02-18 18:05:57 -0500137 @echo "Vendor check OK."
Don Newton98fd8812019-09-23 15:15:02 -0400138
Kent Hagerman3243ee52020-02-26 12:11:55 -0500139lint: lint-mod lint-dockerfile
Don Newton98fd8812019-09-23 15:15:02 -0400140
divyadesai892fab52020-03-24 08:45:09 +0000141test: local-lib-go
Don Newton98fd8812019-09-23 15:15:02 -0400142 @mkdir -p ./tests/results
Kent Hagerman6379e092020-02-18 18:05:57 -0500143 @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Don Newton98fd8812019-09-23 15:15:02 -0400144 RETURN=$$? ;\
Kent Hagerman6379e092020-02-18 18:05:57 -0500145 ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
146 ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
Don Newton98fd8812019-09-23 15:15:02 -0400147 exit $$RETURN
148
Don Newton98fd8812019-09-23 15:15:02 -0400149sca:
Kent Hagerman6379e092020-02-18 18:05:57 -0500150 @rm -rf ./sca-report
Don Newton98fd8812019-09-23 15:15:02 -0400151 @mkdir -p ./sca-report
Kent Hagerman6379e092020-02-18 18:05:57 -0500152 @echo "Running static code analysis..."
153 @${GOLANGCI_LINT} run --deadline=4m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml
154 @echo ""
155 @echo "Static code analysis OK"
Don Newton98fd8812019-09-23 15:15:02 -0400156
157clean:
Kent Hagerman6379e092020-02-18 18:05:57 -0500158 rm -rf ./sca-report
Don Newton98fd8812019-09-23 15:15:02 -0400159
160distclean: clean
161 rm -rf ${VENVDIR}
162
Kent Hagerman6379e092020-02-18 18:05:57 -0500163mod-update:
164 ${GO} mod tidy
165 ${GO} mod vendor